import re
class CarmaTable:
    """    
    """
    """
    (Outside docstring because is not helpful for using the program)
    Variables are
    comments Contains all the comments so they can be written later.
        listed in tuples with the row they follow, or -1 if they
        are at the start. Comments that follow comments will be read
        in after the comments they follow, so comments with the same
        row number will be ordered based upon when they appear in the
        comments list.  
    dict A dictionary conatining keyvalue pairs printed with the format
        #@<type> key=value
    text The ascii text, as it was when open was run.
    table The non comment, non header content, in row|col form.
    names A list of the column names
    types A list of the column types
    units A list of the column units
    """
    def __init__(self,namest=None,typest=None,unitst=None,tablet=None):
        self.table=[]
        self.comments=[]
        self.dict={}
        if unitst!=None:
            self.names=namest
            self.types=typest
            self.units=unitst
            if tablet!=None:
                self.table=tablet
    def addDict(self,newDict):
        """
        addDict(self,newDict)
        This function adds a 
        """
        for key in newDict:
            self.dict[key]=newDict[key]
    def addCol(self,name,type,unit,colnum):
        """
        addCol(name,type,unit,colnum)
        This function adds a column.
        Inputs
            name The name of the column.
            type The type of the column
            unit The unit of the column
            colnum The position of the column
        """
        self.names.insert(colnum,name)
        self.units.insert(colnum,unit)
        self.types.insert(colnum,type)
        for row in self.table:
            row.insert(colnum,"")
    def addComment(self,rownum,newComment,commentNum=None):
        """
        addComment(self,rownum,newComment,commentNum=None)
        This functon adds a comment.
        Inputs
            rownum The row after which to add a comment. -1 for the beginning
                of the file.
            newComment The comment to add (don't include the #)
            commentNum Currently not used.
        """
        #default is to append
        if self.comments:
            if commentNum==None:
                for i,comment in enumerate(self.comments):
                    if comment[0]>rownum:
                        break
                self.comments.insert(i+1,(newComment,rownum))
            else:
                for i,comment in enumerate(self.comments):
                    if comment[1]==rownum:
                        break
                print i
                self.comments.insert(i+commentNum,(newComment,rownum))
        else:
            self.comments=[(newComment,rownum)]
    def addRow(self, data):
        """
        addRow(data)
        This function adds a row to the end of the table with the data that the user inputs
        Inputs
            data A string or a list containing the data for the row. If the input is a string,
                each item of the row should be seperated by a space or multiple spaces
        Outputs
            This method will return an error code upon an error. These codes are
                0Invalid input type (Non list/string)
                1Incorrect length of row
        """
        if type(data) == str:
            temp = data.split(None,len(self.names)-1)
        elif type(data) == type([]):
            temp=[]
            for item in data:
                temp.append(item.__str__())
        else:
            print "Error: The inputted data for the row must be a string or a list."
            return 0
        if len(temp)==len(self.names):
            self.table.append(temp)
        else:
            print "Error: The row is not the correct length"
            return 1
    def editCell(self,col,row,new):
        """
        editCell(col,row,new)
        This function edits a cell.
        Inputs
            col The collumn of the cell to edit.
            row The row of the cell to edit.
            new The string to put in the cell.
        """
        while(len(table)<=row):
            table.append([""]*len(table[0]))
        table[row][cell]=new.__str__()
    def editCol(self,list,colnum):
        """
        editCol(list,colnum)
        This function replaces a column
        Inputs
            list The new column content
            colnum Either a column number
                or a column name
        """
        if isinstance(colnum,str):#Names will be strings
            colnum=self.getColNumber(colnum)
        list = [str(x) for x in list]
        while (len(self.table) < len(list)):
            self.addRow([""]*len(self.names))
        list.extend((len(self.table)-len(list))*[""])
        for (i,item) in enumerate(list):
            self.table[i][colnum]=item
    def DMSconvert(self,dms):
        """
        DMSconvert(dms)
        This takes a dms string and converts it to a float
        Inputs
            dms A string in the form [+|-][D]D:MM:SS
        """
        negative=('-'==dms[0])and -1 or 1
        nums=dms.split(':')
        return (float(nums[0])+negative*(float(nums[1])+float(nums[2])/60)/60) #note that the negative will persist on nums[0]
    def getBooleanCol(self, select):
        """
        getBooleanCol(select)
        This function gets the selected column and returns every entry of the
        column as a boolean
        Inputs
            select The index or name of the column that the user wants
        Output
            The function returns a list whose elements are boolean values from the
            entries of the selected column
        """
        col=self.getCol(select)
        output=[]
        truestuff=("1", "true", "t", "y", "yes")
        falsestuff=("0", "false", "f", "n", "no") 
        for entry in col:
            if entry.lower() in truestuff:
                output.append(True)
            elif entry.lower() in falsestuff:
                output.append(False)
            else:
                raise(Exception("Non boolean"))
        return output
    def getCol(self,select):
        """
        getCol(select)
        This function gets the selected column and returns it as a list.
        Inputs
            select The index or name of the column that the user wants
        Output
            The function returns the column as a list
        """
        if isinstance(select,str):#Names will be strings
            i=self.getColNumber(select)
        if isinstance(select,int):#Indecies will be integers
            i=select
        temp=[]
        if self.table:
            for entry in zip(*self.table)[i]:
                temp.append(entry.strip())
        return temp
    def getColInfo(self):
        """
        getInfo()
        This function gets the header information for the file and stores it for later use.
        """
        self.names=[]
        self.types=[]
        self.units=[]
        temp=re.findall(r"^#\|.*$",self.text,re.MULTILINE)
        for entry in temp[0][2:].split('|'):
            if entry!="":
                self.names.append(entry.strip())
        for entry in temp[1][2:].split('|'):
            if entry!="":
                self.types.append(entry.strip())
        for entry in temp[2][2:].split('|'):
            if entry!="":
                self.units.append(entry.strip())
    def getColName(self,i):
        "gets the name of the input column number"
        return self.names[int(i)]
    def getColNames(self):
        "gets a list of all the names of the columns"
        return self.names[:]
    def getColUnit(self,i):
        "gets the name of the input column number"
        return self.units[int(i)]
    def getColUnits(self):
        "gets a list of all the names of the columns"
        return self.units[:]
    def getColType(self,i):
        "gets the name of the input column number"
        return self.types[int(i)]
    def getColTypes(self):
        "gets a list of all the names of the columns"
        return self.types[:]
    def getColNumber(self,i):
        "gets the number of the input column name"
        return self.names.index(i)
    def getCommentCol(self):
        "returns the comment column as a list"
        return self.getCol(len(self.names)-1)
    def getTable(self):
        return self.table[:]
    def splat(self):
        return self.table[:]
    def getDMSCol(self,select):
        """
        getDMSCol(select)
        This function gets the selected column and returns every entry of the
        column as a float representing the DMS
        Inputs
            select The index or name of the column that the user wants
        Output
            The function returns a list whose elements are DMS values from the
            entries of the selected column
        """
        col=self.getCol(select) 
        output=[]
        for entry in col:
            output.append(self.DMSconvert(entry))
        return output
    def getFloatCol(self,select):
        """
        getFloatCol(select)
        This function gets the selected column and returns every entry of the
        column as a float
        Inputs
            select The index or name of the column that the user wants
        Output
            The function returns a list whose elements are floats values from the
            entries of the selected column
        """
        col=self.getCol(select) 
        output=[]
        for entry in col:
            output.append(float(entry))
        return output
    def getIntCol(self,select):
        """
        getIntCol(select)
        This function gets the selected column and returns every entry of the
        column as a ints
        Inputs
            select The index or name of the column that the user wants
        Output
            The function returns a list whose elements are Ints values from the
            entries of the selected column
        """
        col=self.getCol(select) 
        output=[]
        for entry in col:
            output.append(int(entry))
        return output
    def getNcols(self):
        "Returns the number of columns in the table"
        return len(zip(*self.table))
    def getNrows(self):
        "Returns the number of rows in the table"
        return len(self.table)
    def getRACol(self,select):
        """
        getRACol(select)
        This function gets the selected column and returns every entry of the
        column as a float representing the RA
        Inputs
            select The index or name of the column that the user wants
        Output
            The function returns a list whose elements are RA values from the
            entries of the selected column
        """
        col=self.getCol(select) 
        output=[]
        for entry in col:
            output.append(self.RAconvert(entry))
        return output
    def getDict(self):
        """
        getDict()
        This function gets the list of dictionaries
        """
        return self.dict.copy()
    def getRow(self,i):
        """
        getRow(i)
        This function gets the selected row and returns it as a list.
        Inputs
            select The index of the column that the user wants
        Output
            The function returns the row as a list
        """
        return self.table[i][:]
    def formattingString(self,widths):
        """
        formattingString(widths)
        This function generates a string that can be combined with a tuple
        containing one row to make a correctly spaced row of output.
        Inputs
            lengthsThe widths of each column
        """
        output=""
        for width in widths[:-1]:
            output=output+("%-"+str(width)+"s")
        return output+"%s"
    def maxWidth(self,select):
        """
        maxWidth(select)
        This method calculates the width that a column should be to allow
        all the data to fit.
        Inputs
            select The column index to calculate the width for.
        """
        if select==1:
            lengths=[len(self.names[select])+2,len(self.types[select])+2,len(self.units[select])+2]
        else:
            lengths=[len(self.names[select]),len(self.types[select]),len(self.units[select])]
        col=self.getCol(select)
        for entry in col:
            lengths.append(len(entry))
        return max(lengths)
    def maxWidths(self):
        """
        maxWidths()
        This method calculates the width that all columns should be to allow
        all the data to fit.
        Outputs
            A list of widths for the columns
        """
        output=[]
        for i in range(0,len(self.names)):
            output.append(self.maxWidth(i)+2)
        return output
    def open(self,file):
        """
        open(file)
        This method reads in the contents of a text file into memory to allow
        manipulation of the contents.
        Inputs                                     
            The filename to read from.
        """
        self.filename=file
        fin=open(file)
        self.text=fin.read()
        fin.close()
        self.getColInfo()
        self.comments=[]
        self.dict={}
        self.table=[]
        row=-1
        for line in self.text.split('\n'):
            if line=="#" or (line!="" and line[0]=='#' and line[1]!="|" and line[1]!="@"):
                self.comments.append((line,row))
            elif len(line.split())>=len(self.names) and line[0]!="#":#This insures that there are the right number of cols and it's not header.
                row=row+1
                self.table.append(line.split(None,len(self.names)-1))
            elif line[:2]=="#@":
                temp=line.split()[1].split('=')
                self.dict[temp[0]]=temp[1]
    def putRow(self, i, data):
        """
        putRow(i, data)
        This function adds a row to the index of the table with the data that the user inputs.
        The function adds the row before the indexed row, so that after adding the row to the
        table, the inputted index i is the index of the new row         
        Inputs                                     
            i The index of the table that the user wants to insert the new row into
            data A string or a list containing the data for the row. If the input is a string,
                  each item of the row should be seperated by a space or multiple spaces
        """
        if type(data) == str:
            datalist = data.split(None,len(self.names)-1)
            self.table.insert(i, datalist)
        elif type(data) == type([]):
            self.table.insert(i, data)
        else:
            print "Error: The inputted data for the row must be a string or a list."
    def RAconvert(self,ra):
        """
        RAconvert(RA)
        This takes a dms string and converts it to a float
        Inputs
            RA A string in the form [H]H:MM:SS
        """
        return 15*self.DMSconvert("+"+ra)
    def removeRow(self, i):
        """
        removeRow(i)
        This function removes the row of index i from the table
        Inputs
            i The index of the table that the user wants to remove the row from
        """
        del self.table[i]
    def reRead(self):
        self.open(self.file)
    def setColName(self,select, newName):
        """
        setColName(select,newName)
        This function sets the name of the selected column to newName
        Inputs
            select The index of the column that the user wants to change the name of
            newName The new name that the user wants the column to be called
        """
        self.names[select] = newName
    def setColType(self,select, newType):
        """
        setColType(select,newType)
        This function sets the type of the selected column to newType
        Inputs
            select The index of the column that the user wants to change the type of
            newType The new type that the user wants the column to have
        """
        self.types[select] = newType
    def setColUnit(self, select, newUnit):
        """
        setColUnit(select,newUnit)
        This function sets the units of the selected column to newUnit
        Inputs
            select The index of the column that the user wants to change the units of
            newUnit The new unit that the user wants the column to have
        """
        self.units[select] = newUnit
    def setDict(self,newDict):
        self.dict=newDict
    def toString(self):
        """
        toString()
        This method genrates a text reperesentation of the current table
        Outputs
            The string
        """
        output=""
        if self.table:
            widths=self.maxWidths()
        else:
            widths=[]
            for name in self.names:
                #widths.append(len(name))
                widths.append(0)
        for key in self.dict:
            output+="#@ %s=%s\n"%(key,self.dict[key])
        #Print the leading comments:
        if self.comments:
            for comment in self.comments:
                if comment[1]==-1:
                    output=output+'#'+comment[0]+'\n'
        output=output+"#|"+self.names[0].center(widths[0]-3)+'|'  
        for name,width in zip(self.names,widths)[1:]:
            output=output+name.center(width-1)+'|'
        output=output+"\n#|"+self.types[0].center(widths[0]-3)+'|'  
        for type,width in zip(self.types,widths)[1:]:
            output=output+type.center(width-1)+'|'
        output=output+"\n#|"+self.units[0].center(widths[0]-3)+'|'  
        for unit,width in zip(self.units,widths)[1:]:
            output=output+unit.center(width-1)+'|'
        output=output+"\n"
        #Print the body of the table
        if self.table:
            i=0
            format=self.formattingString(widths)
            for row in self.table:
                if self.comments:
                    for comment in self.comments:
                        if comment[1]==i:
                            output=output+'#'+comment[0]+'\n'
                i=i+1
                output=output+format%tuple(row)+"\n"
            for comment in self.comments:
                if comment[1]>=len(self.table):
                    output=output+'#'+comment[0]+'\n'
        return output
    def write(self,filename):
        """
        write(filename)
        Writes a text reperesentation of the current table to a file.
        Inputs
            filenameThe file to write to
        """
        fout=open(filename,'w')
        fout.write(self.toString())
        fout.close


