#! /bin/env python
#
#  example how to make a Makefile (a Pipefile) that implements a pipeline
#  that is normally called via the "pipe" command

import os, sys



def single_step(i,step='step'):
    print "# step %s %d" % (step,i)
    if step=="step":
        print "%s%d:  .s%d.c" % (step,i,i)
    else:
        print "step%d:  %s" % (i,step)
        print "%s:  .s%d.c" % (step,i)
    if i==1:
        print ".s%d.a:  .s%d.b" % (i,i)
    else:
        print ".s%d.a:  .s%d.a .s%d.b" % (i,i-1,i)
    print ".s%d.b .s%d.c:" % (i,i)
    print "\t@echo Doing %s as step%d " % (step,i)
    if step=="step":
        print "\t@step%d" % (i)
    else:
        print "\t@%s" % (step)
    print "\t@echo %s > .s%d.b" % (step,i)
    print "\t@rm -f .s%d.b" % (i+1)
    print ""

def header_step(n):
    print "# auto-generating pipeline steps for %d steps:" % n
    print ""
    print ""
    s = "STEPSa = "
    for i in range(0,n):
        s = s + " " + ".s%d.a" % (i+1)
    print s
    print "STEPSb = $(STEPSa:.a=.b)"
    print ""
    print "all:  $(STEPSa)"
    print ""
    print "clean:"
    print "\trm -f $(STEPSb)"
    print ""


if __name__ == '__main__':
    if len(sys.argv) > 1:
        msg = "# " 
        for a in sys.argv:
            msg = msg + " %s" %a 
        print msg
        if len(sys.argv) == 2:
            if os.path.exists(sys.argv[1]):
                # use file with step names
                f = open(sys.argv[1])
                lines = f.readlines()
                f.close()
                steps = []
                for line in lines:
                    if line[0] == '#': continue
                    steps.append(line.strip())
                n = len(steps)
                header_step(n)
                for i in range(n,0,-1):
                    single_step(i,steps[i-1])
            else:
                # use integer with default step names
                n = int(sys.argv[1])
                header_step(n)
                for i in range(n,0,-1):
                    single_step(i)
        else:
            n = int(sys.argv[1])
            steps = sys.argv[2:]
            if len(steps) == n:
                header_step(n)
                for i in range(n,0,-1):
                    single_step(i,steps[i-1])
