#! /bin/env python
#


#     use this if you need just to produce offline figures
# import matplotlib
# matplotlib.use('Agg')

import numpy             as np
#import matplotlib.pyplot as plt
import matplotlib.pylab  as plt
#
from scipy.interpolate  import spline
import pylab


__version__ = "MIS data reduction script helper functions: $Id: mis.py,v 1.1.1.1 2011/03/08 19:22:10 pteuben Exp $"




def sexa2dec(dms):
    """
    convert an D:M:S string to D, also works for H:M:S

    Inputs:
        dms     D:M:S string, e.g. "04:05:22.3"
    Returns:
        converted floating point value of D:M:S
    """
    w = dms.split(':')
    if len(w) == 3:
        return float(w[0]) + (float(w[1]) + float(w[2])/60.0)/60.0;
    elif len(w) == 2:
        return float(w[0]) + float(w[1])/60.0;
    elif len(w) == 1:
        return float(w[0])
    else:
        return 0.0

def avector(a):
    """convert ascii list into float list"""
    v = []
    for x in a:
        v.append(float(x))
    return v

def nint(x):
    """
    get nearest integer.  In python2.6 you can use to_integral_value
    """
    if x>0: return int(x+0.5)
    return int(x-0.5)


if __name__ == '__main__':
    print "No __main__ yet, if ever...."
